/*
configurator.h 0.1.0 (2002-Mar-01-Fri)
Adam M. Costello  
http://www.nicemice.net/amc/

Provides access to configuration parameters.

This is ANSI C code.

*/


#ifndef CONFIGURATOR_H
#define CONFIGURATOR_H


/*** Incomplete types ***/

struct configurator;
    /* The entity that provides access  */
    /* to the configuration parameters. */

struct scheduler;
    /* See scheduler.h. */


/*** Functions for using a configurator ***/

Configurator *configurator_new(Scheduler *);

    /* Returns a pointer to a new configurator, or */
    /* a null pointer if one cannot be created.    */


void configurator_delete(Configurator *);

    /* Deletes a configurator.  After it has been       */
    /* deleted, it must not be passed to any functions. */


char *configurator_get_parameter(const char *);

    /* configurator_get_parameter(name) returns the parameter value  */
    /* (which is a string) corresponding to the given name (which is */
    /* also a string), or a null pointer if the name does not exist. */


void configurator_free_parameter(char *);

    /* configurator_free_parameter(value) frees the memory returned */
    /* by configurator_get_parameter().                             */


#endif /* CONFIGURATOR_H */
